unit bblods;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Menus, ExtDlgs;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonBild2: TButton;
    EditBild2: TEdit;
    EditPenColor: TEdit;
    EditPenWidth: TEdit;
    EditText: TEdit;
    Image1: TImage;
    Image2: TImage;
    MemoBruks: TMemo;
    Menu1: TMainMenu;
    Arkiv1: TMenuItem;
    GetTab1: TMenuItem;
    Bruks1: TMenuItem;
    Infoga1: TMenuItem;
    Inbild: TMenuItem;
    Pen1: TMenuItem;
    Text1: TMenuItem;
    OpenPictureDialog2: TOpenPictureDialog;
    New1: TMenuItem;
    SaveBild1: TMenuItem;
    GetBild1: TMenuItem;
    OpenDialog1: TOpenDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;

    procedure Bruks1Click(Sender: TObject);
    procedure ButtonBild2Click(Sender: TObject);
    procedure EditBild2Change(Sender: TObject);
    procedure EditBild2DblClick(Sender: TObject);
    procedure EditPenColorChange(Sender: TObject);
    procedure EditPenColorDblClick(Sender: TObject);
    procedure EditPenWidthChange(Sender: TObject);
    procedure EditPenWidthDblClick(Sender: TObject);
    procedure EditTextDblClick(Sender: TObject);

    procedure FormActivate(Sender: TObject);

    procedure GetBild1Click(Sender: TObject);
    procedure Arkiv1Click(Sender: TObject);
    procedure GetTab1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure InbildClick(Sender: TObject);
    procedure MemoBruksChange(Sender: TObject);
    procedure MemoBruksDblClick(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Pen1Click(Sender: TObject);
    procedure SaveBild1Click(Sender: TObject);
    procedure Text1Click(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  InFil               :TEXT;
  InFilNamn           :STRING;
  punkt1,punkt2       :INTEGER;
  InRad               :STRING;
  TempOrd             :STRING;
  TidStr1a,TidStr1b,
  TidStr2a,TidStr2b,
  ValStr1a,ValStr1b,
  ValStr2a,ValStr2b   :STRING;
  TidInt2a,
  TidInt1,TidInt2,
  ValInt1,ValInt2     :INTEGER;
  Texten              :TRect;
  TempVal1,TempVal2,
  TVal1,TVal2         :INTEGER;
  Bredd               :INTEGER;
  Col                 :INTEGER;
  Rita                :BOOLEAN;
  PenCol              :TColor;


implementation


Procedure GetTab;
Var
        p,p0,pp                    :INTEGER;
        Las                        :BOOLEAN;
Begin

  If FileExists(InFilNamn) then
    Begin
      Form1.Image1.Canvas.Pen.Width:=5;
      TidStr1a:='xxx';
      Assign(InFil,InFilNamn);
      Reset(InFil);
      While (NOT EOF(InFil)) do
        Begin
          ReadLn(InFil,InRad);
           If ((Length(InRad)>2) AND (InRad[2]='a') AND (InRad[3]='b')) then
               Begin
                 TidStr1a:='xxx';

               end;
          If ((Length(InRad)>5) AND (InRad[2]='a') AND (InRad[3]='m')
             AND (InRad[4]='n')) then
               Begin
                { TempOrd:='';
                 For p:=6 to Length(InRad) do
                   Begin
                     TempOrd:=TempOrd+InRad[p];
                   end;
                 TempOrd:='Namn: '+TempOrd;}
                 Texten:=Rect(50,730,400,750);

                 Form1.Image1.Canvas.TextRect(Texten,50,730,InRad);



               end;
          If ((Length(InRad)>13) AND (InRad[2]='e') AND (InRad[3]='r')
             AND (InRad[4]='s') AND (InRad[5]='o') AND (InRad[6]='n')) then
               Begin
               {  TempOrd:='';
                 For p:=14 to Length(InRad) do
                   Begin
                     TempOrd:=TempOrd+InRad[p];
                   end;
                        }
                 Texten:=Rect(50,752,484,772);

                 Form1.Image1.Canvas.TextRect(Texten,50,752,InRad);
               end;
          If ((Length(InRad)>6) AND (InRad[2]='a') AND (InRad[3]='t')
             AND (InRad[4]='u') AND (InRad[5]='m')) then
               Begin
             {    TempOrd:='';
                 For p:=7 to Length(InRad) do
                   Begin
                     TempOrd:=TempOrd+InRad[p];
                   end;
                     }
                 Texten:=Rect(50,772,484,792);

                 Form1.Image1.Canvas.TextRect(Texten,50,772,InRad);
               end;

          If ((Length(InRad)>1) AND (InRad[1]='W')) then
               Begin
                 TempOrd:='';
                 p:=1;
                 Las:=False;
                 While ((p<Length(InRad)) AND(NOT (InRad[p+1]=' '))) do
                   Begin
                     p:=p+1;
                     TempOrd:=TempOrd+InRad[p];

                   end;
                 Val(TempOrd,Bredd,pp);
                 If (pp=0) then Form1.Image1.Canvas.Pen.Width:=Bredd;
                 TempOrd:='';
                 While (p<Length(InRad)) do
                   Begin
                     p:=p+1;
                     If Las then TempOrd:=TempOrd+InRad[p];
                     If (InRad[p]='F') then Las:=True;
                   end;
                 If Length(TempOrd)>0 then
                   Begin
                     Val(TempOrd,Col,pp);
                     If (pp=0) then Form1.Image1.Canvas.Pen.Color:=Col
                       else
                         Begin
                           If (TempOrd='Black') then
                             Form1.Image1.Canvas.Pen.Color:=clBlack;
                           If (TempOrd='Blue') then
                             Form1.Image1.Canvas.Pen.Color:=clBlue;
                           If (TempOrd='Green') then
                             Form1.Image1.Canvas.Pen.Color:=clGreen;
                           If (TempOrd='Red') then
                             Form1.Image1.Canvas.Pen.Color:=clRed;
                           If (TempOrd='Yellow') then
                             Form1.Image1.Canvas.Pen.Color:=clYellow;
                           If (TempOrd='Aqua') then
                             Form1.Image1.Canvas.Pen.Color:=clAqua;
                           If (TempOrd='White') then
                             Form1.Image1.Canvas.Pen.Color:=clWhite;
                           If (TempOrd='Window') then
                             Form1.Image1.Canvas.Pen.Color:=clWindow;
                           If (TempOrd='Bakgrund') then
                             Form1.Image1.Canvas.Pen.Color:=16777113;
                         end;


                   end;
               end;
          ValStr2a:='0';
          ValStr2b:='0';
          p0:=6;
          If  ((Length(InRad)>8) AND (InRad[1] IN['0'..'9'])) then
            Begin
              For p:=1 to Length(InRad) do
                Begin
                  If (p=1) then TidStr2a:=InRad[p];
                  If (p=2) then TidStr2a:=TidStr2a+InRad[p];
                  If (p=4) then TidStr2b:=InRad[p];
                  If (p=5) then TidStr2b:=TidStr2b+InRad[p];
                  If (TidStr2a='') then TidStr2a:='0';
                  If (TidStr2b='') then TidStr2b:='0';
                  If (p=5) then
                    Begin
                      TidInt2a:=StrToInt(TidStr2a);
                      If (TidInt2a<6) then TidInt2a:=24+TidInt2a;
                      TidInt2:=60*TidInt2a+StrToInt(TidStr2b);

                    end;

                  If ((p=p0) AND (InRad[p]=' ')) then p0:=p+1;
                  If (p=p0) then ValStr2a:=InRad[p];
                  If ((p=p0+1) AND (InRad[p] IN['0'..'9'])) then
                    ValStr2a:=ValStr2a+InRad[p];
                  If ((p=p0+2) AND (InRad[p] IN['0'..'9'])) then
                    ValStr2b:=InRad[p];
                  If ((p=p0+3) AND (InRad[p] IN['0'..'9'])
                  AND ((InRad[p0+2]=',') OR (InRad[p0+2]='.'))) then
                    ValStr2b:=InRad[p];
                  If (ValStr2a='') then ValStr2a:='0';
                  If (ValStr2b='') then ValStr2b:='0';
                  If (p>p0) then
                     ValInt2:=10*StrToInt(ValStr2a)+StrToInt(ValStr2b);


                end;

              If ((TidInt1>359) AND (NOT  (TidStr1a='xxx'))) then
                Begin
                  TVal1:=40+Round((TidInt1-360)*960/1440);
                  TVal2:=40+Round((TidInt2-360)*960/1440);
                  TempVal1:=680-Round(3.4*ValInt1);
                  TempVal2:=680-Round(3.4*ValInt2);
                  Form1.Image1.Canvas.Line(TVal1,TempVal1,TVal2,TempVal2);
                end;
             TidStr1a:=TidStr2a;
             TidInt1:=TidInt2;
             ValInt1:=ValInt2;

            end;
        end;
      Close(InFil);
    end;

end;

{************************************************************************
Här börjar händelsehanterare.
*************************************************************************}

{ TForm1 }

procedure TForm1.FormActivate(Sender: TObject);
begin
  PenCol:=0;

end;



procedure TForm1.Bruks1Click(Sender: TObject);
begin
  MemoBruks.Visible:=True;
end;

procedure TForm1.ButtonBild2Click(Sender: TObject);
Var
   FilNamn              :STRING;
begin
   If  OpenPictureDialog1.Execute then
    Begin
      FilNamn:=OpenPictureDialog1.FileName;

      If FileExists(FilNamn) then
         EditBild2.Text:=FilNamn;
    end;
end;

procedure TForm1.EditBild2Change(Sender: TObject);
begin
  If FileExists(EditBild2.Text) then
    Begin
      Image2.Picture.LoadFromFile(EditBild2.Text);
      Image2.Visible:=False;
    end;
end;

procedure TForm1.EditBild2DblClick(Sender: TObject);
begin
  EditBild2.Visible:=False;
  ButtonBild2.Visible:=False;
end;

procedure TForm1.EditPenColorChange(Sender: TObject);
Var
    p,TmpCol          :INTEGER;

begin
   Val(EditPenColor.Text,TmpCol,p);
  If (p=0) then PenCol:=TmpCol;
  If (EditPenColor.Text='Black') then PenCol:=clBlack;
  If (EditPenColor.Text='Blue') then PenCol:=clBlue;
  If (EditPenColor.Text='Green') then PenCol:=clGreen;
  If (EditPenColor.Text='Red') then PenCol:=clRed;
  If (EditPenColor.Text='Yellow') then PenCol:=clYellow;
  If (EditPenColor.Text='Aqua') then PenCol:=clAqua;
  If (EditPenColor.Text='White') then PenCol:=clWhite;
  If (EditPenColor.Text='Window') then PenCol:=clWindow;
  If (EditPenColor.Text='Bakgrund') then PenCol:=16777113;


end;

procedure TForm1.EditPenColorDblClick(Sender: TObject);
begin
  EditPenWidth.Visible:=False;
  EditPenColor.Visible:=False;
end;

procedure TForm1.EditPenWidthChange(Sender: TObject);
  Var
      p,TmpBredd           :INTEGER;

begin
  Val(EditPenWidth.Text,TmpBredd,p);
  If (p=0) then Bredd:=TmpBredd;
end;

procedure TForm1.EditPenWidthDblClick(Sender: TObject);
begin
  EditPenWidth.Visible:=False;
  EditPenColor.Visible:=False;
end;

procedure TForm1.EditTextDblClick(Sender: TObject);
begin
  EditText.Visible:=False;
end;



procedure TForm1.GetBild1Click(Sender: TObject);
Var
   FilNamn              :STRING;
begin
   If  OpenPictureDialog1.Execute then
    Begin
      FilNamn:=OpenPictureDialog1.FileName;

      If FileExists(FilNamn) then
         Image1.Picture.LoadFromFile(FilNamn);
    end;
end;

procedure TForm1.Arkiv1Click(Sender: TObject);
begin

end;

procedure TForm1.GetTab1Click(Sender: TObject);

begin
  If  OpenDialog1.Execute then InFilNamn:=OpenDialog1.FileName;
  If FileExists(InFilNamn) then GetTab;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin

end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

  If EditText.Visible then
    Begin
      Image1.Canvas.TextOut(X,Y,EditText.Text);

    end;

  If EditPenColor.Visible then
    Begin
      Rita:=True;
      Image1.Canvas.Pixels[X,Y]:=PenCol;

    end;

  If EditBild2.Visible then
    Begin
      Image2.Transparent:=True;
      Image2.Left:=X;
      Image2.Top:=Y;
      Image1.Canvas.Draw(X,Y,Image2.Picture.Bitmap);

    end;

end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  Var
       p,pp     :INTEGER;
begin
 If Rita then
    Begin
      For p:=0 to Round(0.5*Bredd) do
        Begin
          For pp:=0 to Round(0.5*Bredd) do
            Begin
              Image1.Canvas.Pixels[X+p,Y+pp]:=PenCol;
              Image1.Canvas.Pixels[X+p,Y-pp]:=PenCol;
              Image1.Canvas.Pixels[X-p,Y+pp]:=PenCol;
              Image1.Canvas.Pixels[X-p,Y-pp]:=PenCol;

            end;
        end;
    end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Rita:=False;
end;

procedure TForm1.InbildClick(Sender: TObject);
begin
  EditBild2.Visible:=True;
  ButtonBild2.Visible:=True;
  EditText.Visible:=False;
  EditPenColor.Visible:=False;
  EditPenWidth.Visible:=False;
end;

procedure TForm1.MemoBruksChange(Sender: TObject);
begin

end;

procedure TForm1.MemoBruksDblClick(Sender: TObject);
begin
  MemoBruks.Visible:=False;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
  Image1.Picture.Clear;

end;

procedure TForm1.Pen1Click(Sender: TObject);
begin
   EditBild2.Visible:=False;
   ButtonBild2.Visible:=False;
   EditText.Visible:=False;
   EditPenColor.Visible:=True;
   EditPenWidth.Visible:=True;
end;

procedure TForm1.SaveBild1Click(Sender: TObject);
Var
     FilNamn         :STRING;
begin

If SavePictureDialog1.Execute then
  Begin
    FilNamn:=SavePictureDialog1.FileName;
    If Length(FilNamn)>2 then
       Begin
         Image1.Picture.SaveToFile(FilNamn);
       end;
   end;

end;

procedure TForm1.Text1Click(Sender: TObject);
begin
   EditBild2.Visible:=False;
   ButtonBild2.Visible:=False;
   EditText.Visible:=True;
   EditPenColor.Visible:=False;
   EditPenWidth.Visible:=False;
end;



initialization
  {$I bblods.lrs}

end.

